import bpy

"""
duplicates all selected ragdoll pieces.
Changes names of duplicates to be 'SEN-<bone_name>'
Parents the duplicate to it's corresponding ragdoll piece
Removes all constraints from the duplicate
Changes game collision settings to be 'sensor type.

Select the ragdoll pieces run script.
"""

SEN_PREFIX = 'SEN-'
obj_seq = bpy.context.selected_objects
bpy.ops.object.select_all(action='TOGGLE')
for i in range(len(obj_seq)):
    #Make Duplicate
    obj_seq[i].select = True
    bpy.ops.object.duplicate_move(OBJECT_OT_duplicate={"linked":False, "mode":'TRANSLATION'}, TRANSFORM_OT_translate={"value":(0, 0, 0), "constraint_axis":(False, False, False), "constraint_orientation":'GLOBAL', "mirror":False, "proportional":'DISABLED', "proportional_edit_falloff":'SMOOTH', "proportional_size":1, "snap":False, "snap_target":'CLOSEST', "snap_point":(0, 0, 0), "snap_align":False, "snap_normal":(0, 0, 0), "texture_space":False, "release_confirm":False})
    obj_seq[i].select = False
    #Rename Duplicate
    duplicate = bpy.data.objects[obj_seq[i].name + '.001']
    duplicate.name = (SEN_PREFIX + obj_seq[i].name[3::])
    #Make Ragdoll piece the parent of the duplicate
    duplicate.select = True
    bpy.context.scene.objects.active = obj_seq[i]
    bpy.ops.object.parent_set(type = 'OBJECT', xmirror = False, keep_transform = True)
    #Remove all constraints from the duplicate
    bpy.context.scene.objects.active = duplicate
    bpy.ops.object.constraints_clear()
    #Change Game Settings
    duplicate.game.physics_type = 'SENSOR'
    duplicate.hide_render = True
    #Move Duplicate to layer 17
    duplicate.layers = [x == 16 for x in range(0, 20)]
    
